!!ARBfp1.0

#modified lighting shader for specular pass
#TODO: replace decal texture with spec mask
#written by Rich Whitehouse
#---------------------------------------------------------------------

#this has become somewhat of a mess.
#texture0 is the decal
#texture1 is the normal map, with dynamic shadow coords in .texcoord
#texture2 is the dynamic shadow texture, with light vectors in .texcoord
#texture3 is the 3d attenuation texture

PARAM	mulf = {2.0, 2.0, 2.0};
PARAM	subf = {-1.0, -1.0, -1.0};
PARAM	expon = program.env[0];
PARAM	lightColor = program.env[1];

OUTPUT	out = result.color;
TEMP	cbrf, nrml, dcal, attn, temp, dshd;

#fetch the textures
TEX	dcal, fragment.texcoord[0], texture[0], 2D;
TEX	nrml, fragment.texcoord[0], texture[1], 2D;
TXP	dshd, fragment.texcoord[1], texture[2], 2D;
TEX	attn, fragment.texcoord[3], texture[3], 3D;

MOV	cbrf, fragment.texcoord[2];

#expand the normals
MAD	nrml, nrml, mulf, subf;
MAD	cbrf, cbrf, mulf, subf;

#now done here instead of relying on cubemap
DP3	temp, cbrf, cbrf;
RSQ	temp, temp.x;
MUL	temp, temp.x, cbrf;

DP3	temp, nrml, temp;
POW	temp, temp.r, expon.x;

MUL	temp, temp, lightColor; #factor in light color

MUL	temp, attn, temp; #factor in attenuation
MUL	temp, dshd, temp; #factor in dynamic shadows

MOV	temp.a, dcal.a; #set alpha component by decal

MOV	out, temp;

END
